# Class JmolPanel

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JPanel
org.openscience.jmol.app.jmolpanel.JmolPanel

All Implemented Interfaces:
  `ImageObserver, MenuContainer, Serializable, Accessible, JsonNioClient, SplashInterface`

Direct Known Subclasses:
  `Jmol, NMR_JmolPanel`

public class JmolPanel extends JPanel implements SplashInterface, JsonNioClient

See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`class`
`JmolPanel.AboutAction`
`protected static class`
`JmolPanel.ActionChangedListener`
`class`
`JmolPanel.AnimButton`
`protected class`
`JmolPanel.AppCloser`
To shutdown when run as an application.
`class`
`JmolPanel.AtomSetChooserAction`
`class`
`JmolPanel.CloseAction`
`class`
`JmolPanel.ConsoleAction`
`class`
`JmolPanel.CopyImageAction`
An Action to copy the current image into the clipboard.
`class`
`JmolPanel.CopyScriptAction`
`class`
`JmolPanel.CreditsAction`
`class`
`JmolPanel.ExecuteScriptAction`
`class`
`JmolPanel.ExitAction`
`class`
`JmolPanel.ExportAction`
`class`
`JmolPanel.GaussianAction`
`class`
`JmolPanel.NewAction`
`class`
`JmolPanel.NewwinAction`
`class`
`JmolPanel.OpenAction`
`class`
`JmolPanel.OpenMolAction`
`class`
`JmolPanel.OpenPdbAction`
`class`
`JmolPanel.OpenUrlAction`
`class`
`JmolPanel.PasteClipboardAction`
`class`
`JmolPanel.PovrayAction`
`class`
`JmolPanel.PrintAction`
`class`
`JmolPanel.RecentFilesAction`
`class`
`JmolPanel.ResizeAction`
`class`
`JmolPanel.ScriptEditorAction`
`class`
`JmolPanel.ScriptWindowAction`
`class`
`JmolPanel.SurfaceToolAction`
`class`
`JmolPanel.ToWebAction`
`class`
`JmolPanel.TwoDEditorAction`
`class`
`JmolPanel.UguideAction`
`class`
`JmolPanel.ViewMeasurementTableAction`
`class`
`JmolPanel.WhatsNewAction`
`class`
`JmolPanel.WriteAction`

### Nested classes/interfaces inherited from class JPanel

`JPanel.AccessibleJPanel`

### Nested classes/interfaces inherited from class JComponent

`JComponent.AccessibleJComponent`

### Nested classes/interfaces inherited from class Container

`Container.AccessibleAWTContainer`

### Nested classes/interfaces inherited from class Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

### Nested classes/interfaces inherited from interface JsonNioClient

`JsonNioClient.TouchHandler`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected static final String`
`aboutAction`
`protected static boolean`
`allowJavaConsole`
`protected String`
`appletContext`
`AtomSetChooser`
`atomSetChooser`
`protected static final String`
`atomsetchooserAction`
`protected static BannerFrame`
`bannerFrame`
`protected JsonNioServer`
`clientService`
`protected static final String`
`closeAction`
`protected Map<String,Action>`
`commands`
`protected static final String`
`consoleAction`
`protected JmolPanel.CopyImageAction`
`copyImageAction`
`protected static final String`
`copyImageActionProperty`
`protected JmolPanel.CopyScriptAction`
`copyScriptAction`
`protected static final String`
`copyScriptActionProperty`
`protected static final String`
`creditsAction`
`DisplayPanel`
`display`
`protected static final String`
`EDITOR_WINDOW_NAME`
`protected static final String`
`editorAction`
`protected JmolPanel.ExecuteScriptAction`
`executeScriptAction`
`protected static final String`
`exitAction`
`protected JmolPanel.ExportAction`
`exportAction`
`protected static final String`
`exportActionProperty`
`protected static final String`
`FILE_OPEN_WINDOW_NAME`
`JFrame`
`frame`
`protected static final String`
`gaussianAction`
`protected GaussianDialog`
`gaussianDialog`
`GuiMap`
`guimap`
`static HistoryFile`
`historyFile`
`protected String`
`imageType`
`protected boolean`
`isPlugin`
`protected JFrame`
`javaConsoleframe`
`JmolApp`
`jmolApp`
`protected JmolJME`
`jmolJME`
`protected static KioskFrame`
`kioskFrame`
`protected MeasurementTable`
`measurementTable`
`protected Map<String, JMenuItem>`
`menuItems`
`protected JmolAdapter`
`modelAdapter`
`protected StatusListener`
`myStatusListener`
`protected static final String`
`newAction`
`protected static final String`
`newwinAction`
`protected static int`
`numWindows`
`protected static final String`
`openAction`
`protected static final String`
`openmolAction`
`protected static final String`
`openpdbAction`
`protected static final String`
`openurlAction`
`static final int`
`OUTSOCKET`
`protected JmolPanel.PasteClipboardAction`
`pasteClipboardAction`
`protected static final String`
`pasteClipboardActionProperty`
`PropertyChangeSupport`
`pcs`
`static HistoryFile`
`pluginFile`
`protected JmolPanel.PovrayAction`
`povrayAction`
`protected static final String`
`povrayActionProperty`
`protected PreferencesDialog`
`preferencesDialog`
`protected JmolPanel.PrintAction`
`printAction`
`protected static final String`
`printActionProperty`
`protected int`
`qualityJPG`
`protected int`
`qualityPNG`
`protected org.openscience.jmol.app.jmolpanel.RecentFilesDialog`
`recentFiles`
`protected static final String`
`recentFilesAction`
`protected static final String`
`resizeAction`
`protected static final Dimension`
`screenSize`
`protected static final String`
`SCRIPT_WINDOW_NAME`
`SplashInterface`
`splash`
`protected int`
`startupHeight`
`protected int`
`startupWidth`
`protected StatusBar`
`status`
`protected SurfaceTool`
`surfaceTool`
`protected static final String`
`SURFACETOOL_WINDOW_NAME`
`protected JmolPanel.SurfaceToolAction`
`surfaceToolAction`
`protected static final String`
`surfaceToolActionProperty`
`protected JToolBar`
`toolbar`
`protected JmolPanel.ToWebAction`
`toWebAction`
`protected static final String`
`toWebActionProperty`
`protected JmolPanel.TwoDEditorAction`
`twoDEditorAction`
`protected static final String`
`twoDEditorActionProperty`
`protected static final String`
`uguideAction`
`protected JmolPanel.ViewMeasurementTableAction`
`viewMeasurementTableAction`
`Viewer`
`vwr`
`protected Map<String,Object>`
`vwrOptions`
`protected static final String`
`WEB_MAKER_WINDOW_NAME`
`protected static final String`
`whatsnewAction`
`protected String`
`windowName`
`protected JmolPanel.WriteAction`
`writeAction`
`protected static final String`
`writeActionProperty`

### Fields inherited from class JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

### Fields inherited from interface JsonNioClient

`TYPES`

## Constructor Summary

Constructors
Constructor
Description
`JmolPanel(JmolApp jmolApp, Splash splash, JFrame frame, JmolPanel parent, int startupWidth, int startupHeight, Map<String,Object> vwrOptions, Point loc)`

## Method Summary

Modifier and Type
Method
Description
`protected void`
`addHelpMenuBar(JMenuBar menuBar)`
`static void`
`addJmolProperties(Properties props)`
`static void`
`addJmolProperty(String key, String value)`
`static void`
`addJmolWindowInfo(String name, Component window, Point border)`
Deprecated.
`static void`
`addJmolWindowInnerInfo(String name, Component window, Dimension inner)`
`protected void`
`addMacrosMenu(JMenuBar menuBar)`
`protected void`
`addNormalMenuBar(JMenuBar menuBar)`
`protected void`
`addPluginMenu(JMenuBar mb)`
`protected void`
`createDisplayAndAddStatusListener()`
`protected GuiMap`
`createGuiMap()`
`JMenu`
`createMenu(String key)`
Create a menu for the app.
`protected JMenuBar`
`createMenubar()`
Create the menubar for the app.
`JMenuItem`
`createMenuItem(String cmd)`
This is the hook through which all menu items are created.
`protected StatusBar`
`createStatusBar()`
`protected JToolBar`
`createToolBar()`
Create the toolbar.
`protected AbstractButton`
`createToolbarButton(String key)`
Create a button to go inside of the toolbar.
`protected boolean`
`doClose(boolean saveSize)`
`protected Action`
`getAction(String cmd)`
Fetch the action that was created for the given command.
`protected JmolPlugin`
`getAndRegisterPlugin(String name, String path)`
`AppConsole`
`getConsole()`
`protected void`
`getDialogs()`
`protected List<Action>`
`getFrameActions()`
`protected ImageIcon`
`getIconX(String img)`
`static Object`
`getInstanceWithParams(String name, Class<?>[] classes, Object... params)`
`void`
`getJavaConsole()`
`protected static void`
`getJavaConsole(Jmol jmol)`
Deprecated.
`static String`
`getJmolProperty(String key, String defaultValue)`
`static JsonNioServer`
`getJsonNioServer()`
`protected void`
`getMeasurementTable()`
`protected JMenuItem`
`getMenuItem(String cmd)`
Fetch the menu item that was created for the given command.
`static String`
`getPluginOption(String pluginName, String key, String defaultValue)`
`Object`
`getPreference(String key)`
`protected String`
`getStringX(String cmd)`
`static File`
`getUserDirectory()`
Returns a new File referenced by the property 'user.dir', or null if the property is not defined.
`protected String`
`getWindowName()`
`boolean`
`isServer()`
`protected void`
`launchMainFrame()`
`protected JToolBar`
`newToolbar(String[] keys)`
`void`
`nioClosed(JsonNioServer jns)`
/////// JSON/NIO SERVICE //////////
`void`
`notifyFileOpen(String fullPathName, String title)`
`void`
`notifyGaussian(CBK type, Object[] data)`
`void`
`notifyGeneralCallback(CBK type, Object[] data, String strInfo)`
`void`
`notifyLanguage()`
`CBK`
`notifyMeasure(Object[] data)`
`void`
`notifyMenu(String menuName)`
`void`
`notifyNBO(String strInfo)`
`void`
`notifyNBO(Map<String,Object> info)`
`void`
`notifyPreferences(Object[] data)`
`void`
`notifyServer(CBK type, Object[] data)`
`void`
`print()`
added print command, so that it can be used by RasmolScriptHandler
`void`
`processNioMessage(byte[] packet)`
`protected void`
`report(String str)`
`int[]`
`resizeInnerPanel(String data)`
`protected void`
`saveWindowSizes()`
`protected void`
`say(String message)`
`void`
`sendNioSyncRequest(Object data, int port, String strInfo)`
`void`
`serverCycle()`
`protected void`
`setAtomChooser()`
`protected void`
`setCommandHooks()`
`protected void`
`setFrameLocation(Point loc, JmolPanel parent)`
`protected void`
`setIntoFrame()`
`protected String`
`setMenuKeys(String key, String tokens)`
opportunity to adjust menus for a custom application
`protected void`
`setMenuState()`
`static void`
`setPluginOption(String pluginName, String key, String value)`
`void`
`setStatus(int pos, String msg)`
`protected void`
`setupConsole()`
`protected void`
`setupDisplay()`
`protected void`
`setupDnD()`
`protected void`
`setupModelAdapterAndViewer()`
`void`
`showStatus(String message)`
`void`
`updateConsoleFont()`

### Methods inherited from class JPanel

`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

### Methods inherited from class JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

### Methods inherited from class Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### historyFile

public static HistoryFile historyFile

### pluginFile

public static HistoryFile pluginFile

### vwr

public Viewer vwr

### modelAdapter

protected JmolAdapter modelAdapter

### jmolApp

public JmolApp jmolApp

### status

protected StatusBar status

### startupWidth

protected int startupWidth

### startupHeight

protected int startupHeight

### appletContext

protected String appletContext

### pcs

public PropertyChangeSupport pcs

### display

public DisplayPanel display

### gaussianDialog

protected GaussianDialog gaussianDialog

### recentFiles

protected org.openscience.jmol.app.jmolpanel.RecentFilesDialog recentFiles

### atomSetChooser

public AtomSetChooser atomSetChooser

### frame

public JFrame frame

### splash

public SplashInterface splash

### javaConsoleframe

protected JFrame javaConsoleframe

### clientService

protected JsonNioServer clientService

### qualityJPG

protected int qualityJPG

### qualityPNG

protected int qualityPNG

### imageType

protected String imageType

### guimap

public GuiMap guimap

### executeScriptAction

protected JmolPanel.ExecuteScriptAction executeScriptAction

### preferencesDialog

protected PreferencesDialog preferencesDialog

### myStatusListener

protected StatusListener myStatusListener

### surfaceTool

protected SurfaceTool surfaceTool

### measurementTable

protected MeasurementTable measurementTable

### jmolJME

protected JmolJME jmolJME

### commands

protected Map<String,Action> commands

### menuItems

protected Map<String, JMenuItem> menuItems

### toolbar

protected JToolBar toolbar

### twoDEditorAction

protected JmolPanel.TwoDEditorAction twoDEditorAction

### exportAction

protected JmolPanel.ExportAction exportAction

### povrayAction

protected JmolPanel.PovrayAction povrayAction

### toWebAction

protected JmolPanel.ToWebAction toWebAction

### writeAction

protected JmolPanel.WriteAction writeAction

### printAction

protected JmolPanel.PrintAction printAction

### copyImageAction

protected JmolPanel.CopyImageAction copyImageAction

### copyScriptAction

protected JmolPanel.CopyScriptAction copyScriptAction

### surfaceToolAction

protected JmolPanel.SurfaceToolAction surfaceToolAction

### pasteClipboardAction

protected JmolPanel.PasteClipboardAction pasteClipboardAction

### viewMeasurementTableAction

protected JmolPanel.ViewMeasurementTableAction viewMeasurementTableAction

### vwrOptions

protected Map<String,Object> vwrOptions

### windowName

protected String windowName

### isPlugin

protected boolean isPlugin

### numWindows

protected static int numWindows

### kioskFrame

protected static KioskFrame kioskFrame

### bannerFrame

protected static BannerFrame bannerFrame

### allowJavaConsole

protected static boolean allowJavaConsole

### EDITOR_WINDOW_NAME

protected static final String EDITOR_WINDOW_NAME

See Also:
  - Constant Field Values

### SCRIPT_WINDOW_NAME

protected static final String SCRIPT_WINDOW_NAME

See Also:
  - Constant Field Values

### FILE_OPEN_WINDOW_NAME

protected static final String FILE_OPEN_WINDOW_NAME

See Also:
  - Constant Field Values

### WEB_MAKER_WINDOW_NAME

protected static final String WEB_MAKER_WINDOW_NAME

See Also:
  - Constant Field Values

### SURFACETOOL_WINDOW_NAME

protected static final String SURFACETOOL_WINDOW_NAME

See Also:
  - Constant Field Values

### screenSize

protected static final Dimension screenSize

### newwinAction

protected static final String newwinAction

See Also:
  - Constant Field Values

### openAction

protected static final String openAction

See Also:
  - Constant Field Values

### openurlAction

protected static final String openurlAction

See Also:
  - Constant Field Values

### openpdbAction

protected static final String openpdbAction

See Also:
  - Constant Field Values

### openmolAction

protected static final String openmolAction

See Also:
  - Constant Field Values

### newAction

protected static final String newAction

See Also:
  - Constant Field Values

### twoDEditorActionProperty

protected static final String twoDEditorActionProperty

See Also:
  - Constant Field Values

### exportActionProperty

protected static final String exportActionProperty

See Also:
  - Constant Field Values

### closeAction

protected static final String closeAction

See Also:
  - Constant Field Values

### exitAction

protected static final String exitAction

See Also:
  - Constant Field Values

### aboutAction

protected static final String aboutAction

See Also:
  - Constant Field Values

### whatsnewAction

protected static final String whatsnewAction

See Also:
  - Constant Field Values

### creditsAction

protected static final String creditsAction

See Also:
  - Constant Field Values

### uguideAction

protected static final String uguideAction

See Also:
  - Constant Field Values

### printActionProperty

protected static final String printActionProperty

See Also:
  - Constant Field Values

### recentFilesAction

protected static final String recentFilesAction

See Also:
  - Constant Field Values

### povrayActionProperty

protected static final String povrayActionProperty

See Also:
  - Constant Field Values

### writeActionProperty

protected static final String writeActionProperty

See Also:
  - Constant Field Values

### editorAction

protected static final String editorAction

See Also:
  - Constant Field Values

### consoleAction

protected static final String consoleAction

See Also:
  - Constant Field Values

### toWebActionProperty

protected static final String toWebActionProperty

See Also:
  - Constant Field Values

### atomsetchooserAction

protected static final String atomsetchooserAction

See Also:
  - Constant Field Values

### copyImageActionProperty

protected static final String copyImageActionProperty

See Also:
  - Constant Field Values

### copyScriptActionProperty

protected static final String copyScriptActionProperty

See Also:
  - Constant Field Values

### surfaceToolActionProperty

protected static final String surfaceToolActionProperty

See Also:
  - Constant Field Values

### pasteClipboardActionProperty

protected static final String pasteClipboardActionProperty

See Also:
  - Constant Field Values

### gaussianAction

protected static final String gaussianAction

See Also:
  - Constant Field Values

### resizeAction

protected static final String resizeAction

See Also:
  - Constant Field Values

### OUTSOCKET

public static final int OUTSOCKET

See Also:
  - Constant Field Values

## Constructor Details

### JmolPanel

public JmolPanel(JmolApp jmolApp, Splash splash, JFrame frame, JmolPanel parent, int startupWidth, int startupHeight, Map<String,Object> vwrOptions, Point loc)

## Method Details

### getFrameActions

protected List<Action> getFrameActions()

Returns:
  A list of Actions that is understood by the upper level application

### getStringX

protected String getStringX(String cmd)

### getIconX

protected ImageIcon getIconX(String img)

### getWindowName

protected String getWindowName()

### createGuiMap

protected GuiMap createGuiMap()

### createStatusBar

protected StatusBar createStatusBar()

### createToolBar

protected JToolBar createToolBar()
Create the toolbar. By default this reads the resource file for the definition of the toolbars.

Returns:
  The toolbar

### newToolbar

protected JToolBar newToolbar(String[] keys)

### createDisplayAndAddStatusListener

protected void createDisplayAndAddStatusListener()

### setupModelAdapterAndViewer

protected void setupModelAdapterAndViewer()

### getDialogs

protected void getDialogs()

### getMeasurementTable

protected void getMeasurementTable()

### setCommandHooks

protected void setCommandHooks()

### setupDisplay

protected void setupDisplay()

### setFrameLocation

protected void setFrameLocation(Point loc, JmolPanel parent)

### setIntoFrame

protected void setIntoFrame()

### setupConsole

protected void setupConsole()

### setupDnD

protected void setupDnD()

### setAtomChooser

protected void setAtomChooser()

### launchMainFrame

protected void launchMainFrame()

### getJavaConsole

@Deprecated protected static void getJavaConsole(Jmol jmol)
Deprecated.

### getJavaConsole

public void getJavaConsole()

### showStatus

public void showStatus(String message)

Specified by:
  `showStatus` in interface `SplashInterface`

### report

protected void report(String str)

### say

protected void say(String message)

### doClose

protected boolean doClose(boolean saveSize)

### saveWindowSizes

protected void saveWindowSizes()

### createMenuItem

public JMenuItem createMenuItem(String cmd)
This is the hook through which all menu items are created. It registers the result with the menuitem hashtable so that it can be fetched with getMenuItem().

Parameters:
  `cmd` -
Returns:
  Menu item created
See Also:
  - `getMenuItem(String)`

### getMenuItem

protected JMenuItem getMenuItem(String cmd)
Fetch the menu item that was created for the given command.

Parameters:
  `cmd` - Name of the action.
Returns:
  item created for the given command or null if one wasn't created.

### getAction

protected Action getAction(String cmd)
Fetch the action that was created for the given command.

Parameters:
  `cmd` - Name of the action.
Returns:
  The action

### createToolbarButton

protected AbstractButton createToolbarButton(String key)
Create a button to go inside of the toolbar. By default this will load an image resource. The image filename is relative to the classpath (including the '.' directory if its a part of the classpath), and may either be in a JAR file or a separate file.

Parameters:
  `key` - The key in the resource file to serve as the basis of lookups.
Returns:
  Button

### createMenubar

protected JMenuBar createMenubar()
Create the menubar for the app. By default this pulls the definition of the menu from the associated resource file.

Returns:
  Menubar

### addPluginMenu

protected void addPluginMenu(JMenuBar mb)

### addMacrosMenu

protected void addMacrosMenu(JMenuBar menuBar)

### addNormalMenuBar

protected void addNormalMenuBar(JMenuBar menuBar)

### addHelpMenuBar

protected void addHelpMenuBar(JMenuBar menuBar)

### createMenu

public JMenu createMenu(String key)
Create a menu for the app. By default this pulls the definition of the menu from the associated resource file.

Parameters:
  `key` -
Returns:
  Menu created

### setMenuKeys

protected String setMenuKeys(String key, String tokens)
opportunity to adjust menus for a custom application

Parameters:
  `key` -
  `tokens` -
Returns:
  possibly changed token string

### setMenuState

protected void setMenuState()

### getAndRegisterPlugin

protected JmolPlugin getAndRegisterPlugin(String name, String path)

### getInstanceWithParams

public static Object getInstanceWithParams(String name, Class<?>[] classes, Object... params)

### print

public void print()
added print command, so that it can be used by RasmolScriptHandler

### getUserDirectory

public static File getUserDirectory()
Returns a new File referenced by the property 'user.dir', or null if the property is not defined.

Returns:
  a File to the user directory

### notifyFileOpen

public void notifyFileOpen(String fullPathName, String title)

### resizeInnerPanel

public int[] resizeInnerPanel(String data)

### nioClosed

public void nioClosed(JsonNioServer jns)
/////// JSON/NIO SERVICE //////////

Specified by:
  `nioClosed` in interface `JsonNioClient`

### sendNioSyncRequest

public void sendNioSyncRequest(Object data, int port, String strInfo)

### getJsonNioServer

public static JsonNioServer getJsonNioServer()

### updateConsoleFont

public void updateConsoleFont()

### getPreference

public Object getPreference(String key)

### getConsole

public AppConsole getConsole()

### getJmolProperty

public static String getJmolProperty(String key, String defaultValue)

### setPluginOption

public static void setPluginOption(String pluginName, String key, String value)

### getPluginOption

public static String getPluginOption(String pluginName, String key, String defaultValue)

### addJmolProperties

public static void addJmolProperties(Properties props)

### addJmolProperty

public static void addJmolProperty(String key, String value)

### setStatus

public void setStatus(int pos, String msg)

### addJmolWindowInfo

@Deprecated public static void addJmolWindowInfo(String name, Component window, Point border)
Deprecated.
Deprecated -- use addJmolWindowInnerInfo(name,window,Dimension inner)

Parameters:
  `name` -
  `window` -
  `border` -

### addJmolWindowInnerInfo

public static void addJmolWindowInnerInfo(String name, Component window, Dimension inner)

### processNioMessage

public void processNioMessage(byte[] packet) throws Exception

Specified by:
  `processNioMessage` in interface `JsonNioClient`
Throws:
  `Exception`

### serverCycle

public void serverCycle()

Specified by:
  `serverCycle` in interface `JsonNioClient`

### isServer

public boolean isServer()

### notifyServer

public void notifyServer(CBK type, Object[] data)

### notifyNBO

public void notifyNBO(String strInfo)

### notifyNBO

public void notifyNBO(Map<String,Object> info)

### notifyGaussian

public void notifyGaussian(CBK type, Object[] data)

### notifyMenu

public void notifyMenu(String menuName)

### notifyMeasure

public CBK notifyMeasure(Object[] data)

### notifyPreferences

public void notifyPreferences(Object[] data)

### notifyLanguage

public void notifyLanguage()

### notifyGeneralCallback

public void notifyGeneralCallback(CBK type, Object[] data, String strInfo)